import QtQuick 1.1
import com.nokia.meego 1.0
import "storage.js" as Storage

Page {
    id: second
    tools: commonTools
    orientationLock: PageOrientation.LockPortrait

    Image {source: "images/back.jpg"; fillMode: Image.Tile; anchors.fill: parent}
    Image {source: "images/box.png"; fillMode: Image.Stretch; x: 335; y: 600}

    Button {
        anchors.horizontalCenter: parent.horizontalCenter
        y: 20
        height: 75
        width: 375
        text: "E-Mail Accounts"
        iconSource: "images/email.png"
        onClicked: {mainPage.hTipi = "1"
                    mainPage.sData1 = "User Name "
                    mainPage.sData2 = "Server    "
                    mainPage.sData3 = "E-Mail    "
                    pageStack.push(Qt.resolvedUrl("Account.qml"))}
    }

    Button {
        anchors.horizontalCenter: parent.horizontalCenter
        y: 110
        height: 75
        width: 375
        text: "Credit Card Accounts"
        iconSource: "images/card.png"
        onClicked: {mainPage.hTipi = "2"
                    mainPage.sData1 = "CVV           "
                    mainPage.sData2 = "Card No    "
                    mainPage.sData3 = "Expiration"
                    pageStack.push(Qt.resolvedUrl("Account.qml"))}
    }

    Button {
        anchors.horizontalCenter: parent.horizontalCenter
        y: 200
        height: 75
        width: 375
        text: "Links"
        iconSource: "images/conn.png"
        onClicked: {mainPage.hTipi = "3"
                    mainPage.sData1 = "User Name "
                    mainPage.sData2 = "Server    "
                    mainPage.sData3 = "E-Mail    "
                    pageStack.push(Qt.resolvedUrl("Account.qml"))}
    }

    Button {
        anchors.horizontalCenter: parent.horizontalCenter
        y: 290
        height: 75
        width: 375
        text: "Web Site Accounts"
        iconSource: "images/web.png"
        onClicked: {mainPage.hTipi = "4"
                    mainPage.sData1 = "User Name "
                    mainPage.sData2 = "Server    "
                    mainPage.sData3 = "E-Mail    "
                    pageStack.push(Qt.resolvedUrl("Account.qml"))}
    }

    Button {
        anchors.horizontalCenter: parent.horizontalCenter
        y: 380
        height: 75
        width: 375
        text: "Other Accounts"
        iconSource: "images/other.png"
        onClicked: {mainPage.hTipi = "5"
                    mainPage.sData1 = "User Name "
                    mainPage.sData2 = "Other     "
                    mainPage.sData3 = "E-Mail    "
                    pageStack.push(Qt.resolvedUrl("Account.qml"))}
    }

    Button {
        x: 20
        y: 525
        text: "Reset Password!"
        width: 225
        onClicked: {Storage.dropTable(0)
                    pageStack.push(Qt.resolvedUrl("MainPage.qml"))}
    }

    Label {
        x: 255
        y: 530
        color: "#666666"
        font.pixelSize: 18
        text: "*Pass. to enter application\nwill be reset."
    }

    Text {
        x: 20
        y: 625
        color: "#666666"
        font.italic: true
        font.pixelSize: 16
        text: "<b>Account Box</b>, keeps your personal account<br>" +
              "informations securely by encrypting in a<br>" +
              "special database for remember."
    }

    Text {
        x: 20
        y: 700
        color: "#666666"
        font.bold: true
        font.pixelSize: 18
        text: "© 2012 apps-dev."
    }

    ToolBarLayout {
        id: commonTools
        visible: true
        ToolIcon {
            platformIconId: "toolbar-view-menu"
            anchors.right: (parent === undefined) ? undefined : parent.right
            onClicked: (myMenu.status == DialogStatus.Closed) ? myMenu.open() : myMenu.close()
        }
    }

}
