import QtQuick 1.1
import com.nokia.meego 1.0
import "storage.js" as Storage
import "crypto.js" as Crypto

Page {
    id: first
    tools: commonTools
    property string ilkmi: ""
    property string hTipi: "1"
    property string sData1: ""
    property string sData2: ""
    property string sData3: ""

    Component.onCompleted: {
        Storage.initialize();
        ilkmi = Storage.getSetting(0,1,"pass")
    }

    Image {source: "images/back.jpg"; fillMode: Image.Tile; anchors.fill: parent}
    Image {source: "images/box.png"; fillMode: Image.Stretch; x: 335; y: 600}

    Label {
        x: 20
        y: 32
        color: "#333333"
        text: if (ilkmi == "Unknown!") { "New Pass. :" }
              else { "Enter Pass. :" }
    }

    TextField {
        id: myPassword
        x: 170
        y: 20
        width: 280
        maximumLength: 15
        echoMode: TextInput.Password
        text: ""
    }

    Label {
        id: myPromotion
        x: 20
        y: 120
        color: "#666666"
        font.italic: true
        font.pixelSize: 18
        text: "*You must enter your first password on home screen<br>" +
              "before to use this application.<br><br>" +
              "*You must type this password for adding new account<br>" +
              "and see it.<br><br>" +
              "*If you're using this application <b>first time</b>, please type<br>" +
              "your first password.<br>"
    }

    Label {
        id: myStatus
        x: 20
        y: 400
        font.bold: true
        font.pixelSize: 24
        text: ""
    }

    Button {
        x: 20
        y: 335
        width: 240
        text: "Login »"
        onClicked: {
            if (ilkmi == "Unknown!") {
                if (myPassword.text != "") {
                    Storage.setSetting(0,1,Crypto.base64Encode(myPassword.text))
                    myStatus.text = "<font color='LimeGreen'>New Password Saved!</font>"
                    pageStack.push(Qt.resolvedUrl("Categori.qml"))
                } else {
                    myStatus.text = "<font color='Tomato'>Password Field Empty!</font>"
                }
            } else {
                if (myPassword.text == Crypto.base64Decode(Storage.getSetting(0,1,"pass"))) {
                    myStatus.text = "<font color='LimeGreen'>Login Approved!</font>"
                    pageStack.push(Qt.resolvedUrl("Categori.qml"))
                } else {
                    myStatus.text = "<font color='Tomato'>Login Deprecated!</font>"
                    myPassword.text = ""
                    myPassword.focus = true
                }
            }
        }
    }

    Text {
        x: 20
        y: 625
        color: "#666666"
        font.italic: true
        font.pixelSize: 16
        text: "<b>Account Box</b>, keeps your personal account<br>" +
              "informations securely by encrypting in a<br>" +
              "special database for remember."
    }

    Text {
        x: 20
        y: 700
        color: "#666666"
        font.bold: true
        font.pixelSize: 18
        text: "© 2012 apps-dev."
    }

    ToolBarLayout {
        id: commonTools
        visible: true
        ToolIcon {
            platformIconId: "toolbar-view-menu"
            anchors.right: (parent === undefined) ? undefined : parent.right
            onClicked: (myMenu.status == DialogStatus.Closed) ? myMenu.open() : myMenu.close()
        }
    }

}
